<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>Framework: framework::core::Socket Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Framework
   </div>
   <div id="projectbrief">Framework drone</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classframework_1_1core_1_1_socket.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Properties</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classframework_1_1core_1_1_socket-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">framework::core::Socket Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class encapsulating a UDP socket. It assumes packets are coming from only one distant host on a given port.  
 <a href="classframework_1_1core_1_1_socket.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_socket_8h_source.html">Socket.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for framework::core::Socket:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classframework_1_1core_1_1_socket.png" usemap="#framework::core::Socket_map" alt=""/>
  <map id="framework::core::Socket_map" name="framework::core::Socket_map">
<area href="classframework_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. " alt="framework::core::Object" shape="rect" coords="0,0,147,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6fe908569147879dbc8145dfd8c38e11"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#a6fe908569147879dbc8145dfd8c38e11">Socket</a> (const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *parent, std::string name, std::string address, bool broadcast=false)</td></tr>
<tr class="memdesc:a6fe908569147879dbc8145dfd8c38e11"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a6fe908569147879dbc8145dfd8c38e11">More...</a><br /></td></tr>
<tr class="separator:a6fe908569147879dbc8145dfd8c38e11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1adeecee1e256f3c4f34f7698b3103c7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#a1adeecee1e256f3c4f34f7698b3103c7">Socket</a> (const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *parent, std::string name, uint16_t port)</td></tr>
<tr class="memdesc:a1adeecee1e256f3c4f34f7698b3103c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a1adeecee1e256f3c4f34f7698b3103c7">More...</a><br /></td></tr>
<tr class="separator:a1adeecee1e256f3c4f34f7698b3103c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70089bda092e48d729cc4afe0e5c1668"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#a70089bda092e48d729cc4afe0e5c1668">~Socket</a> ()</td></tr>
<tr class="memdesc:a70089bda092e48d729cc4afe0e5c1668"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a70089bda092e48d729cc4afe0e5c1668">More...</a><br /></td></tr>
<tr class="separator:a70089bda092e48d729cc4afe0e5c1668"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f8c016a5eee95d7d3b3749f6d43314d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#a9f8c016a5eee95d7d3b3749f6d43314d">SendMessage</a> (std::string message)</td></tr>
<tr class="memdesc:a9f8c016a5eee95d7d3b3749f6d43314d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message.  <a href="#a9f8c016a5eee95d7d3b3749f6d43314d">More...</a><br /></td></tr>
<tr class="separator:a9f8c016a5eee95d7d3b3749f6d43314d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afee28668d5dd69e004bdcde32e25193b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#afee28668d5dd69e004bdcde32e25193b">SendMessage</a> (const char *message, size_t message_len)</td></tr>
<tr class="memdesc:afee28668d5dd69e004bdcde32e25193b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message.  <a href="#afee28668d5dd69e004bdcde32e25193b">More...</a><br /></td></tr>
<tr class="separator:afee28668d5dd69e004bdcde32e25193b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa07455775017781fdf8981e7ad6bd44b"><td class="memItemLeft" align="right" valign="top">ssize_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_socket.html#aa07455775017781fdf8981e7ad6bd44b">RecvMessage</a> (char *buf, size_t buf_len, <a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a> timeout, char *src=NULL, size_t *src_len=NULL)</td></tr>
<tr class="memdesc:aa07455775017781fdf8981e7ad6bd44b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Receive a message.  <a href="#aa07455775017781fdf8981e7ad6bd44b">More...</a><br /></td></tr>
<tr class="separator:aa07455775017781fdf8981e7ad6bd44b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c597b3214c4ed5f549de470114ae6d9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4c597b3214c4ed5f549de470114ae6d9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>NetworkToHost</b> (char *data, size_t dataSize)</td></tr>
<tr class="separator:a4c597b3214c4ed5f549de470114ae6d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af052f52f5a940a107958947d3fc06c97"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af052f52f5a940a107958947d3fc06c97"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>HostToNetwork</b> (char *data, size_t dataSize)</td></tr>
<tr class="separator:af052f52f5a940a107958947d3fc06c97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classframework_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classframework_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classframework_1_1core_1_1_object.html">framework::core::Object</a></td></tr>
<tr class="memitem:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a97617b01df8aedc07b2ba46ef4988994">Object</a> (const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *parent=NULL, std::string name=&quot;&quot;, std::string type=&quot;&quot;)</td></tr>
<tr class="memdesc:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a97617b01df8aedc07b2ba46ef4988994">More...</a><br /></td></tr>
<tr class="separator:a97617b01df8aedc07b2ba46ef4988994 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#ac934815b59eb1cf1a47bdb114fa86da0">~Object</a> ()</td></tr>
<tr class="memdesc:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#ac934815b59eb1cf1a47bdb114fa86da0">More...</a><br /></td></tr>
<tr class="separator:ac934815b59eb1cf1a47bdb114fa86da0 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#ae19cf04d95b4cabb8c6064375b15337f">ObjectName</a> (void) const </td></tr>
<tr class="memdesc:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name.  <a href="#ae19cf04d95b4cabb8c6064375b15337f">More...</a><br /></td></tr>
<tr class="separator:ae19cf04d95b4cabb8c6064375b15337f inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a49660b572cdbedc6a665d5d396ed00a1">ObjectType</a> (void) const </td></tr>
<tr class="memdesc:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type.  <a href="#a49660b572cdbedc6a665d5d396ed00a1">More...</a><br /></td></tr>
<tr class="separator:a49660b572cdbedc6a665d5d396ed00a1 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a8dda2eca639eb56bb2c3f26de04f2678">Parent</a> (void) const </td></tr>
<tr class="memdesc:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parent.  <a href="#a8dda2eca639eb56bb2c3f26de04f2678">More...</a><br /></td></tr>
<tr class="separator:a8dda2eca639eb56bb2c3f26de04f2678 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a7fb6234586cd406b3bea93aadf01ba16">TypeChilds</a> (void) const </td></tr>
<tr class="memdesc:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs of the same type.  <a href="#a7fb6234586cd406b3bea93aadf01ba16">More...</a><br /></td></tr>
<tr class="separator:a7fb6234586cd406b3bea93aadf01ba16 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#aee8de0c31d51e165fed466a4c8bcf6c4">Childs</a> (void) const </td></tr>
<tr class="memdesc:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs.  <a href="#aee8de0c31d51e165fed466a4c8bcf6c4">More...</a><br /></td></tr>
<tr class="separator:aee8de0c31d51e165fed466a4c8bcf6c4 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#aec1974099e78e731ba9c3dd1ed05de94">Information</a> (const char *function, int line, const char *format,...) const </td></tr>
<tr class="memdesc:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted information.  <a href="#aec1974099e78e731ba9c3dd1ed05de94">More...</a><br /></td></tr>
<tr class="separator:aec1974099e78e731ba9c3dd1ed05de94 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#abb73af04b52a2ba67a2d2ce1a74330a2">Warning</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted warning.  <a href="#abb73af04b52a2ba67a2d2ce1a74330a2">More...</a><br /></td></tr>
<tr class="separator:abb73af04b52a2ba67a2d2ce1a74330a2 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a6f48a765168b2fe4a629234e0b778559">Error</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted error.  <a href="#a6f48a765168b2fe4a629234e0b778559">More...</a><br /></td></tr>
<tr class="separator:a6f48a765168b2fe4a629234e0b778559 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classframework_1_1core_1_1_object.html#a56a6221f2ce124d7c53b15a423a47b08">ErrorOccured</a> (bool recursive=true) const </td></tr>
<tr class="memdesc:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Has an errror occured?  <a href="#a56a6221f2ce124d7c53b15a423a47b08">More...</a><br /></td></tr>
<tr class="separator:a56a6221f2ce124d7c53b15a423a47b08 inherit pub_methods_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classframework_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classframework_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classframework_1_1core_1_1_object.html">framework::core::Object</a></td></tr>
<tr class="memitem:a7201b52b50f64586d1ea82cc1f6a2e6f inherit pub_types_classframework_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7201b52b50f64586d1ea82cc1f6a2e6f"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>color_t</b> { <b>Auto</b> =0, 
<b>Red</b> =31, 
<b>Green</b> =32, 
<b>Orange</b> =33
 }</td></tr>
<tr class="separator:a7201b52b50f64586d1ea82cc1f6a2e6f inherit pub_types_classframework_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class encapsulating a UDP socket. It assumes packets are coming from only one distant host on a given port. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a6fe908569147879dbc8145dfd8c38e11"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Socket::Socket </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>broadcast</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct the client side of the socket</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parent</td><td>parent </td></tr>
    <tr><td class="paramname">name</td><td>name </td></tr>
    <tr><td class="paramname">address</td><td>server address (ex 192.168.1.1:9000) </td></tr>
    <tr><td class="paramname">broadcast</td><td>true if address is a broadcast address </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1adeecee1e256f3c4f34f7698b3103c7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Socket::Socket </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classframework_1_1core_1_1_object.html">Object</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct the server side of the socket</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parent</td><td>parent </td></tr>
    <tr><td class="paramname">name</td><td>name </td></tr>
    <tr><td class="paramname">port</td><td>listening port </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a70089bda092e48d729cc4afe0e5c1668"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">framework::core::Socket::~Socket </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a9f8c016a5eee95d7d3b3749f6d43314d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Socket::SendMessage </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>message</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message. </p>
<p>In case of a broadcast <a class="el" href="classframework_1_1core_1_1_socket.html" title="Class encapsulating a UDP socket. It assumes packets are coming from only one distant host on a given...">Socket</a>, <a class="el" href="classframework_1_1core_1_1_object.html#a8dda2eca639eb56bb2c3f26de04f2678" title="Parent. ">Parent()</a>-&gt;<a class="el" href="classframework_1_1core_1_1_object.html#ae19cf04d95b4cabb8c6064375b15337f" title="Name. ">ObjectName()</a> is used as source of the message, this name should be unique.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">message</td><td>message </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afee28668d5dd69e004bdcde32e25193b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void framework::core::Socket::SendMessage </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>message</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>message_len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">message</td><td>message </td></tr>
    <tr><td class="paramname">message_len</td><td>message length </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa07455775017781fdf8981e7ad6bd44b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ssize_t framework::core::Socket::RecvMessage </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>buf_len</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceframework_1_1core.html#a556a09521d9b94e1c9f0bfe6744d611d">Time</a>&#160;</td>
          <td class="paramname"><em>timeout</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>src</em> = <code>NULL</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t *&#160;</td>
          <td class="paramname"><em>src_len</em> = <code>NULL</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Receive a message. </p>
<p>Receive a message and wait up to timeout. <br />
If src and src_len are specified, the source of the message will be copied in the src buffer. <br />
Note that in case of a broadcast socket, own messages are filtered and are not received.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>buffer to put the message </td></tr>
    <tr><td class="paramname">buf_len</td><td>buffer length </td></tr>
    <tr><td class="paramname">timeout</td><td>timeout </td></tr>
    <tr><td class="paramname">src</td><td>buffer to put source name </td></tr>
    <tr><td class="paramname">src_len</td><td>buffer length</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>size of the received message </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceframework.html">framework</a></li><li class="navelem"><a class="el" href="namespaceframework_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classframework_1_1core_1_1_socket.html">Socket</a></li>
    <li class="footer">Generated on Tue Apr 12 2016 16:28:59 for Framework by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.7 </li>
  </ul>
</div>
</body>
</html>
